/* -----------------------------------------------------------------------------------------------------
ϸ : get_host_byaddr.c 
   : hostent ü   α׷
 : cc -o get_host_byaddr get_host_byaddr.c -lnsl
 : get_host_byaddr 192.203.144.11
----------------------------------------------------------------------------------------------------- */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

int main(int argc, char *argv[]) {
  char *host;
  struct hostent	 *myhost;		
  struct in_addr	 in;

  if(argc < 2) {	
    printf(" : %s IP ּ(dotted decimal) \n", argv[0]);
    exit(0);
  }

  /* hostent ϱ */
  host = argv[1];						/* dotted decimal ּ */
  in.s_addr = inet_addr(host);			/* 32bit ּ */
  myhost = gethostbyaddr((char *)&(in.s_addr), sizeof(in.s_addr), AF_INET);
  if (myhost == NULL) {
    printf("Error at gethostbyaddr() \n");
    exit(0);
   }

   /* ȣƮ ̸  */
   printf("official host name : \t\t%s\n", myhost->h_name);
}
