/*--------------------------------------------------------------------------------------------------------
ϸ : talk_client.c
   : ũ  1:1  ϴ Ŭ̾Ʈ α׷   
 : cc -o talk_client talk_client.c -lsocket -lnsl
 : talk_client 192.203.144.11 3000
-------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#define MAXLINE 1024

char *escapechar = "exit";				/* Ṯ  */
int main(int argc, char *argv[]) {
   char line[MAXLINE], sendline[MAXLINE], recvline[MAXLINE+1];
   int n, size, comp;
   pid_t pid;
   static int s;
   static struct sockaddr_in server_addr;

   /* ɹ Է  ó */
   if (argc != 3)  {
      printf(": %s server_IP port \n", argv[0]);
      exit(0);
   }

   /*   */
   if((s = socket(PF_INET, SOCK_STREAM, 0)) < 0)  {
      printf("Client: Can't open stream socket.\n");
      exit(0);
   }
   /* server_addr '0' ʱȭ */
   bzero((char *)&server_addr, sizeof(server_addr));
   /* server_addr  */
   server_addr.sin_family = AF_INET;
   server_addr.sin_addr.s_addr = inet_addr(argv[1]);
   server_addr.sin_port = htons(atoi(argv[2]));
   
   /*   û */
   if(connect(s,(struct sockaddr *)&server_addr,sizeof(server_addr)) < 0) {
      printf("Client: can't connect to server.\n");
      exit(0);
   }
   
   if(( pid = fork()) > 0)  {
      /* θ μ Ű Է   */
      while(fgets(sendline, MAXLINE, stdin) != NULL)  {
        size = strlen(sendline);
	     	if(write(s, sendline, strlen(sendline)) != size) printf("Error in write\n");
	     	/* Ṯڿ Է ó */
        	if (strstr(sendline, escapechar) != NULL ) {
				printf("Good bye.\n");
           	close(s);
				exit(0);
        	}
      }
   } else if (pid == 0) {
      /* ڽ μ κ  ޽ ȭ鿡  */
      while(1) {
	   		if((size = read(s, recvline, MAXLINE)) < 0) {
				printf("Error if read\n");
        		close(s);
				exit(0);
			}
	      	recvline[size] =  '\0';
        	/* Ṯڿ Ž  */
	      	if (strstr(recvline, escapechar) != NULL )  break;
			/* ȭ  */
	      	printf("%s", recvline);
	     }
  }
	close(s);
}
