// ϸ: RMIChatServer.java
//   : RMI ̿ ä 
// : javac RMIChatServer.java,  rmic RMIChatServer
// : java RMIChatServer

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.LocateRegistry;
import java.util.*;

public class RMIChatServer extends UnicastRemoteObject 
		implements RMIChatServerInterface {
	Vector clientList = new Vector();

	// 
	public RMIChatServer() throws RemoteException { }
	
	public static void main(String args[]) {
		try {
			// ü ε
			System.out.println("RMIChatServer.main: creating registry");
			RMIChatServer Server = new RMIChatServer();		// ü 
			Naming.rebind("//:" + "/RMIChatServer", Server);
			System.out.println("RMIChatServer is running ...");
		} catch (Exception e) {
			System.out.println("RMIChatServer error: " + e.getMessage());
			e.printStackTrace();
		}
	}
	// Ŭ̾Ʈ Ϸ ȣϴ  ޼ҵ
	public void connect(RMIChatClientInterface client, String name) 
			throws RemoteException {
		clientList.addElement(client);
		broadcast(name + " Ͽϴ.");
		System.out.println("New Client ! Number of client  = " + (clientList.size() ));
	}
	
	// Ŭ̾Ʈ    ȣϴ  ޼ҵ
	public void disconnect(RMIChatClientInterface client, String name) 
			throws RemoteException {
		int i = clientList.indexOf(client);
		if (i >= 0) {
			broadcast(name + " ä ŻϿϴ.");
			clientList.removeElementAt(i);
			System.out.println("A Client exited! Number of client = "+ clientList.size());
		} else {
				System.out.println("No such a client in Server! ");
		}
	}
	//  Ŭ̾Ʈ ޽ ϴ  ޼ҵ 
	public void broadcast(String msg) throws RemoteException {
		int numOfConnect = clientList.size();
		for(int i = 0; i < numOfConnect; i++) {
			RMIChatClientInterface x = (RMIChatClientInterface) clientList.elementAt(i);
			x.displayMessage(msg);
		}
	}
}

