/*-------------------------------------------------------------------------------------------------------
ϸ : myecho_daemon.c 
   : myecho_server.c  α׷  
 : cc -o myecho_daemon myecho_daemon -lsocket
 : myecho_daemon 6000
-------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <syslog.h>
#include <stdarg.h>
#define BUF_LEN 128
#define MAXFD		64

int main(int argc, char *argv[]) {
  struct sockaddr_in server_addr, client_addr;
  int server_fd, client_fd;	/*  ȣ */
  int i, len, len_out;
  pid_t	pid;
  char buf[BUF_LEN+1];

  if (argc != 2) {
      printf(": %s port\n", argv[0]);
      exit(0);
  }

	/*  α׷  μ  */
  if ((pid = fork()) != 0) 
	exit(0);								/* θ μ Ų */
										/* , ڽ μ Ʒ κ Ѵ */
  setsid();							/* Ǹ  */
	signal(SIGHUP, SIG_IGN); 	/* SIFHUP ñ׳ Ѵ */
	if ((pid = fork()) != 0) 			/* ٽ ڽ μ()  */
		exit(0);							/* θ μ Ų */
	chdir ("/");							/* 丮  */
	umask(0);
	for (i = 0 ; i < MAXFD ; i++) 
		close(i);						/* Ȥ Ǿ  𸣴  ݴ´ */

  /*   */
  if ((server_fd = socket(PF_INET, SOCK_STREAM, 0)) < 0) exit(0);
  /* server_addr '\0' ʱȭ */
  bzero((char *)&server_addr, sizeof(server_addr));
  /* server_addr  */
  server_addr.sin_family = AF_INET;
  server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  server_addr.sin_port = htons(atoi(argv[1]));

  /* bind ȣ */
  if(bind(server_fd, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) 
      exit(0);

  /*     */
  listen(server_fd, 5);

  /* interactive echo   */
  while(1) {
     len = sizeof(client_addr);
     
     /* û ٸ */
     if (client_fd = accept(server_fd, (struct sockaddr *)&client_addr, &len) < 0) 
     		exit(0);
     if (len_out = read(client_fd, buf, sizeof(buf)) < 0) 
			exit(0);
     write(client_fd, buf, len_out);
     close(client_fd);
  }
  close(server_fd);
}
