// ϸ: JavaChatClient.java
//   : ڹ  ̿ ä Ŭ̾Ʈ
// : javac JavaChatClient.java
// : appletviewer JavaChatClient.html

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class JavaChatClient extends Applet implements Runnable {
	final int PORT = 3000;
	Thread readMessage = null;				//  ޽ д  
	
	Socket s;
	DataInputStream dis;
	DataOutputStream dos;
	Button connect, disconnect;				// ,  ư
	TextArea memo;							 	// â
	TextField name;								//  ̸ Է â
	TextField field;								// ä ޽ Է â
	boolean connect_flag = false;				//    ÷
	
	// ø init() ޼ҵ
	public void init() {

		// ̸ Էâ,   Ż ư
		Panel p = new Panel();
		Label label = new Label("My Name:");
		name = new TextField("noname");
		connect = new Button("Connect");
		connect.addActionListener(new ConnectListener());
		disconnect = new Button("Disconnect");
		disconnect.addActionListener(new DisconnectListener());
		p.add(label);
		p.add(name);
		p.add(connect);
		p.add(disconnect);
		
		// ޽  â
		memo = new TextArea();
		memo.setEditable(false);			
		field = new TextField();
		field.addActionListener(new SendListener());
		
		setLayout(new BorderLayout());
		add(p, BorderLayout.NORTH);
		add(memo, BorderLayout.CENTER);
		add(field, BorderLayout.SOUTH);
	}
	
	// (Connect) ư ó 
	class ConnectListener implements ActionListener {
		public void actionPerformed(ActionEvent ae) {
			if(connect_flag == false) {
				try {
					s = new Socket(getCodeBase().getHost(), PORT);
					dis = new DataInputStream(new
						 BufferedInputStream(s.getInputStream()));
					dos = new DataOutputStream(new
						 BufferedOutputStream(s.getOutputStream()));
				} catch(IOException e) {
					memo.append("Can't open Socket\n");
					return;
				}
				memo.append("Connected successfully! \n");
				
				//    
				makeReadMessageThread();
				readMessage.start();			
			
				// ڽ ʱ   
				try {
					dos.writeUTF(name.getText()+":  Ͽϴ.");
					dos.flush();
				} catch(IOException e) {	
					memo.append("Connection error\n");
 				}
				connect_flag = true;
			} 	else {
				// ߺ  õ ó
				memo.append("You are already connedted\n");		
			}
		}
	}
		
	void makeReadMessageThread() {
			readMessage = new Thread(this);
	}
	
	//    (ä ޽ о ȭ鿡 )
	public void run() {
		String data = null;
		while(connect_flag) {
			try {
				data = dis.readUTF() + '\n';
			} catch(IOException e) { memo.append("read error"); }
			memo.append(data);
		}
	}

	// ä ޽ ۽ ó 
	class SendListener implements ActionListener {
		public void actionPerformed(ActionEvent ae) {
			String msg = "["+name.getText()+"] "+ field.getText();
			try {
				dos.writeUTF(msg);
				dos.flush();
			} catch(IOException e) {
				memo.append("Sending error\n");
			}
			field.setText("");
		}
	}
	// (Disconnect) ư ó 
	class DisconnectListener implements ActionListener {
		public void actionPerformed(ActionEvent ae) {
			connect_flag = false;
			try {
				dos.writeUTF(name.getText()+":BYE");
				dos.flush();
			} catch(IOException e) { }
			try {
				dos.close();
				dis.close();
				s.close();
			} catch(IOException e) { }
		}
	}
}
