// ϸ: UDPMyEcho.java
//   : DatagramSocket ̿  Ŭ̾Ʈ
// : javac UDPMyEcho.java
// : java UDPMyEcho localhost 3000

import java.net.*;
import java.io.*;

public class UDPMyEcho {
	final static int MAXBUFFER =  512;
	public static void main(String[] args) {
		if (args.length != 2) {
			System.out.println(": java UDPMyEcho localhost port(3000)");
			System.exit(0);
		}
		byte buffer[] = new byte[MAXBUFFER];
		int port = Integer.parseInt(args[1]);
    		
		try {
			InetAddress inetaddr = InetAddress.getByName(args[0]);
			DatagramSocket socket = new DatagramSocket();
    		DatagramPacket send_packet;			// ۽ſ ͱ׷ Ŷ
    		DatagramPacket recv_packet;			// ſ ͱ׷ Ŷ
    		
			BufferedReader br = new BufferedReader(new 
				InputStreamReader(System.in));

			while (true) {						
					// Ű Է б
					System.out.print("Input Data : ");		
					String data = br.readLine();							
					buffer = data.getBytes();		// Ʈ Ʈ ̷ ٲ
					//  ۽
					send_packet = new DatagramPacket (buffer, buffer.length,
						inetaddr, port);
    				socket.send (send_packet);
					//   
	    	  		recv_packet = new DatagramPacket (buffer, buffer.length);
					socket.receive (recv_packet);
					// ȭ 
					String result = new String(buffer);					
					System.out.println("Echo  Data : "+ result);
    			}
   	} catch (UnknownHostException ex) {
			System.out.println("Error in the host address ");
    	} catch (IOException e) { 
    		System.out.println(e);
    	}
  	}
}
