// ϸ : URLTest.java
//    : ӵ URL  ´.
//  : javac URLTest.java
//  : java URLTest http://telecom.kangwon.ac.kr/index.html

import java.net.*;
import java.io.*;
class URLTest {
    public static void main(String args[]) {
        	URL url = null;
			BufferedReader br;     
	   		String inputLine;
			String host = args[0];
		try {
			url= new URL(host);
			System.out.println("protocol = " + url.getProtocol());
			System.out.println("host = " + url.getHost());
			System.out.println("filename = " + url.getFile());
			System.out.println("port = " + url.getPort());
			System.out.println("ref = " + url.getRef());
			br = new BufferedReader(new InputStreamReader(url.openStream()));
 			while ((inputLine = br.readLine()) != null) {
     			System.out.println(inputLine);
     		}
			br.close();
    	} catch (MalformedURLException me) {
        System.out.println("MalformedURLException: " + me);
     } catch (IOException ioe) {
        System.out.println("IOException: " + ioe);
     }
   }
}

