// ϸ: RMIChatServerInterface.java
//   : RMI ̿ ä  ̽
// : javac RMIChatServerInterface.java

import java.lang.String;
import java.rmi.Remote;
import java.rmi.RemoteException;

public interface RMIChatServerInterface extends Remote {
    public void connect(RMIChatClientInterface client, String name) 
			throws RemoteException;
    public void disconnect(RMIChatClientInterface client, String name) 
			throws RemoteException;
    public void broadcast(String msg) throws RemoteException;
}
