// ϸ: RMIDayTimeImpl.java
//   : RMI ̿ daytime  ̽ 
// : javac RMIDayTimeImpl.java, rmic RMIDayTimeImpl

import java.rmi.*;
import java.rmi.server.*;
import java.util.Date;
public class RMIDayTimeImpl extends UnicastRemoteObject implements RMIDayTime {
  public RMIDayTimeImpl() throws RemoteException { }

	public static void main (String[] args) throws Exception {
    RMIDayTimeImpl remoteServer = new RMIDayTimeImpl();
    Naming.rebind ("RMI-DayTime-Server", remoteServer);
  }

  public Date sendDayTime() {
    return new Date();
  }
}
